require("Script.camera")

function love.load()
   width = love.graphics.getWidth() --Tamano de la pantalla en width.
   height = love.graphics.getHeight() --Tamano de la pantalla en height.
   camera:setBounds(0, 0, width, height)
   
   player = {
     image = love.graphics.newImage("Imagenes/player.png"),
     width = 32,
     height = 32,
     x = 0,
     y = 400,
     speed = 100,
     vidas = 5,
     gravedad = 1.5,
     InAir = false,
     speedy = 100
   }
 
   maping()
   piso = love.graphics.newImage("Imagenes/piso.png") --Carga la imagen del piso.
   fondo = love.graphics.newImage("Imagenes/sielo.png") --Carga la imagen de fondo.
   BarTitle = love.graphics.newImage("Imagenes/BarTitle.png") --Carga la imagen de la barra de titulo.
   
   vida = {}
   
   for i = 1, player.vidas do 
      vidas = {}
      vidas.image = love.graphics.newImage("Imagenes/Heard.png")
      vidas.width = 16
      vidas.height = 16
      vidas.x = i * (vidas.width + 5) + 35
      vidas.y = 17
      table.insert(vida, vidas)
   end
   
end

function maping()
    map = {
    {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1}
    }
end

--Function para dibujar las vidas.
function DrawVidas()
   for i, v in pairs(vida) do 
      love.graphics.draw(v.image, v.x, v.y)
   end
end

--Function para eliminar las vidas.
function RemVidas()
   table.remove(vida, player.vidas) --Quita las vidas.
   player.vidas = player.vidas - 1
end

function love.draw()
   love.graphics.draw(BarTitle) --Dibuja la barra de titulo.
   
   love.graphics.print("Vidas:", 15, 18)
   
   --Dibuja las vidas.
   DrawVidas()
   
   camera:set() -- Meter aqui todo lo que decees para que la camara lo mueva.
   
   --dibuja el cielo.
   --love.graphics.draw(fondo, 0, 50)
   
   --dibuja al jugador.
   love.graphics.draw(player.image, player.x, player.y) --Dibuja al jugador.
   
   --dibuja el piso.
   for y=1, #map do
      for x=1, #map[y] do
         if map[y][x] == 1 then
            love.graphics.draw(piso, x * 32 - 32, y * 32 - 8) --Dibuja el piso.
         end
      end
   end
   camera:unset() --Fin de la function de la camara.
   
end

function love.keypressed(key)

   if key=="f" then
      love.graphics.toggleFullscreen( )
   end
   
   if key == "x" and player.y < 550 and not player.inAir then
      player.speedy = -20
      player.inAir = true
   end
   
end

function love.update(dt)

   frame = dt * 30
   player.speedy = player.speedy + player.gravedad * frame
   player.y = player.y + player.speedy * frame
   
   if love.keyboard.isDown("right") then
      player.x = player.x + player.speed * dt
   elseif love.keyboard.isDown("left") then
      player.x = player.x - player.speed * dt
   end
   
   if love.keyboard.isDown("z") then
      RemVidas()
   end
   
   --Psiciona la camara en el medio.
   camera:setPosition(player.x - width / 2, player.y - height / 2)
   
   if IsCollider(player.x, player.y) == true then
      player.y = player.y - player.speedy * frame
      player.speedy = 0
      player.inAir = false
   end
   
   --Collicion con las paredes x, y.
   if player.x < 0 then
      player.x = 0
   elseif player.y < BarTitle:getHeight() then
      player.y = 50
   end
   
   if player.x > width + width - 32 then
      player.x = width + width - 32
   end
end

--comprueba si hay collipcion con el piso.
function IsCollider(mousex, mousey)
   
   local x1 = math.floor((mousex + player.width) / 32)
   local y1 = math.floor((mousey + player.height) / 32)
   
   if map[y1][x1] == 1 then
      return true
   else
      return false
   end
end


